#line 17 "src/sampler/ConditionalParticleSampler.birch"
birch::type::ConditionalParticleSampler::ConditionalParticleSampler(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_) :
    #line 17 "src/sampler/ConditionalParticleSampler.birch"
    super_type_() {
  //
}

#line 18 "src/sampler/ConditionalParticleSampler.birch"
void birch::type::ConditionalParticleSampler::sample(const libbirch::Lazy<libbirch::Shared<birch::type::ParticleFilter>>& filter, const libbirch::Lazy<libbirch::Shared<birch::type::Model>>& archetype, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_) {
  #line 18 "src/sampler/ConditionalParticleSampler.birch"
  libbirch_function_("sample", "src/sampler/ConditionalParticleSampler.birch", 18);
  #line 19 "src/sampler/ConditionalParticleSampler.birch"
  libbirch_line_(19);
  #line 19 "src/sampler/ConditionalParticleSampler.birch"
  auto conditionalFilter = libbirch::cast<libbirch::Lazy<libbirch::Shared<birch::type::ConditionalParticleFilter>>>(filter);
  #line 20 "src/sampler/ConditionalParticleSampler.birch"
  libbirch_line_(20);
  #line 20 "src/sampler/ConditionalParticleSampler.birch"
  if (conditionalFilter.query()) {
    #line 21 "src/sampler/ConditionalParticleSampler.birch"
    libbirch_line_(21);
    #line 21 "src/sampler/ConditionalParticleSampler.birch"
    this_()->sample(conditionalFilter.get(), archetype, handler_);
  } else {
    #line 23 "src/sampler/ConditionalParticleSampler.birch"
    libbirch_line_(23);
    #line 23 "src/sampler/ConditionalParticleSampler.birch"
    birch::error(birch::type::String("A ConditionalParticleSampler requires a ConditionalParticleFilter."), handler_);
  }
}

#line 27 "src/sampler/ConditionalParticleSampler.birch"
void birch::type::ConditionalParticleSampler::sample(const libbirch::Lazy<libbirch::Shared<birch::type::ParticleFilter>>& filter, const libbirch::Lazy<libbirch::Shared<birch::type::Model>>& archetype, const birch::type::Integer& t, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_) {
  #line 27 "src/sampler/ConditionalParticleSampler.birch"
  libbirch_function_("sample", "src/sampler/ConditionalParticleSampler.birch", 27);
  #line 29 "src/sampler/ConditionalParticleSampler.birch"
  libbirch_line_(29);
  #line 29 "src/sampler/ConditionalParticleSampler.birch"
  auto conditionalFilter = libbirch::cast<libbirch::Lazy<libbirch::Shared<birch::type::ConditionalParticleFilter>>>(filter);
  #line 30 "src/sampler/ConditionalParticleSampler.birch"
  libbirch_line_(30);
  #line 30 "src/sampler/ConditionalParticleSampler.birch"
  if (conditionalFilter.query()) {
    #line 31 "src/sampler/ConditionalParticleSampler.birch"
    libbirch_line_(31);
    #line 31 "src/sampler/ConditionalParticleSampler.birch"
    this_()->sample(conditionalFilter.get(), archetype, t, handler_);
  } else {
    #line 33 "src/sampler/ConditionalParticleSampler.birch"
    libbirch_line_(33);
    #line 33 "src/sampler/ConditionalParticleSampler.birch"
    birch::error(birch::type::String("A ConditionalParticleSampler requires a ConditionalParticleFilter."), handler_);
  }
}

#line 1 "src/sampler/MarginalizedParticleGibbsSampler.birch"
birch::type::MarginalizedParticleGibbsSampler::MarginalizedParticleGibbsSampler(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_) :
    #line 1 "src/sampler/MarginalizedParticleGibbsSampler.birch"
    super_type_() {
  //
}

#line 18 "src/sampler/MarginalizedParticleGibbsSampler.birch"
void birch::type::MarginalizedParticleGibbsSampler::sample(const libbirch::Lazy<libbirch::Shared<birch::type::ConditionalParticleFilter>>& filter, const libbirch::Lazy<libbirch::Shared<birch::type::Model>>& archetype, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_) {
  #line 18 "src/sampler/MarginalizedParticleGibbsSampler.birch"
  libbirch_function_("sample", "src/sampler/MarginalizedParticleGibbsSampler.birch", 18);
  #line 20 "src/sampler/MarginalizedParticleGibbsSampler.birch"
  libbirch_line_(20);
  #line 20 "src/sampler/MarginalizedParticleGibbsSampler.birch"
  filter->alreadyInitialized = false;
}

#line 23 "src/sampler/MarginalizedParticleGibbsSampler.birch"
void birch::type::MarginalizedParticleGibbsSampler::sample(const libbirch::Lazy<libbirch::Shared<birch::type::ConditionalParticleFilter>>& filter, const libbirch::Lazy<libbirch::Shared<birch::type::Model>>& archetype, const birch::type::Integer& n, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_) {
  #line 23 "src/sampler/MarginalizedParticleGibbsSampler.birch"
  libbirch_function_("sample", "src/sampler/MarginalizedParticleGibbsSampler.birch", 23);
  #line 25 "src/sampler/MarginalizedParticleGibbsSampler.birch"
  libbirch_line_(25);
  #line 25 "src/sampler/MarginalizedParticleGibbsSampler.birch"
  this_()->clearDiagnostics(handler_);
  #line 26 "src/sampler/MarginalizedParticleGibbsSampler.birch"
  libbirch_line_(26);
  #line 26 "src/sampler/MarginalizedParticleGibbsSampler.birch"
  filter->initialize(archetype, handler_);
  #line 27 "src/sampler/MarginalizedParticleGibbsSampler.birch"
  libbirch_line_(27);
  #line 27 "src/sampler/MarginalizedParticleGibbsSampler.birch"
  filter->filter(handler_);
  #line 28 "src/sampler/MarginalizedParticleGibbsSampler.birch"
  libbirch_line_(28);
  #line 28 "src/sampler/MarginalizedParticleGibbsSampler.birch"
  this_()->pushDiagnostics(filter, handler_);
  #line 29 "src/sampler/MarginalizedParticleGibbsSampler.birch"
  libbirch_line_(29);
  #line 29 "src/sampler/MarginalizedParticleGibbsSampler.birch"
  for (auto t = birch::type::Integer(1); t <= filter->size(handler_); ++t) {
    #line 30 "src/sampler/MarginalizedParticleGibbsSampler.birch"
    libbirch_line_(30);
    #line 30 "src/sampler/MarginalizedParticleGibbsSampler.birch"
    filter->filter(t, handler_);
    #line 31 "src/sampler/MarginalizedParticleGibbsSampler.birch"
    libbirch_line_(31);
    #line 31 "src/sampler/MarginalizedParticleGibbsSampler.birch"
    this_()->pushDiagnostics(filter, handler_);
  }
  #line 35 "src/sampler/MarginalizedParticleGibbsSampler.birch"
  libbirch_line_(35);
  #line 35 "src/sampler/MarginalizedParticleGibbsSampler.birch"
  filter->b = birch::ancestor(filter->w, handler_);
  #line 36 "src/sampler/MarginalizedParticleGibbsSampler.birch"
  libbirch_line_(36);
  #line 36 "src/sampler/MarginalizedParticleGibbsSampler.birch"
  if (filter->b == birch::type::Integer(0)) {
    #line 37 "src/sampler/MarginalizedParticleGibbsSampler.birch"
    libbirch_line_(37);
    #line 37 "src/sampler/MarginalizedParticleGibbsSampler.birch"
    birch::error(birch::type::String("particle filter degenerated"), handler_);
  }
  #line 39 "src/sampler/MarginalizedParticleGibbsSampler.birch"
  libbirch_line_(39);
  #line 39 "src/sampler/MarginalizedParticleGibbsSampler.birch"
  this_()->x = filter->x.get(libbirch::make_slice(filter->b - 1))->m;
  #line 40 "src/sampler/MarginalizedParticleGibbsSampler.birch"
  libbirch_line_(40);
  #line 40 "src/sampler/MarginalizedParticleGibbsSampler.birch"
  this_()->w = 0.0;
  #line 42 "src/sampler/MarginalizedParticleGibbsSampler.birch"
  libbirch_line_(42);
  #line 42 "src/sampler/MarginalizedParticleGibbsSampler.birch"
  birch::collect(handler_);
}

#line 1 "src/sampler/MarginalizedParticleGibbsSampler.birch"
birch::type::MarginalizedParticleGibbsSampler* birch::type::make_MarginalizedParticleGibbsSampler_() {
  #line 1 "src/sampler/MarginalizedParticleGibbsSampler.birch"
  return new birch::type::MarginalizedParticleGibbsSampler();
  #line 1 "src/sampler/MarginalizedParticleGibbsSampler.birch"
}

#line 1 "src/sampler/MarginalizedParticleImportanceSampler.birch"
birch::type::MarginalizedParticleImportanceSampler::MarginalizedParticleImportanceSampler(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_) :
    #line 1 "src/sampler/MarginalizedParticleImportanceSampler.birch"
    super_type_() {
  //
}

#line 18 "src/sampler/MarginalizedParticleImportanceSampler.birch"
void birch::type::MarginalizedParticleImportanceSampler::sample(const libbirch::Lazy<libbirch::Shared<birch::type::ParticleFilter>>& filter, const libbirch::Lazy<libbirch::Shared<birch::type::Model>>& archetype, const birch::type::Integer& n, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_) {
  #line 18 "src/sampler/MarginalizedParticleImportanceSampler.birch"
  libbirch_function_("sample", "src/sampler/MarginalizedParticleImportanceSampler.birch", 18);
  #line 20 "src/sampler/MarginalizedParticleImportanceSampler.birch"
  libbirch_line_(20);
  #line 20 "src/sampler/MarginalizedParticleImportanceSampler.birch"
  this_()->clearDiagnostics(handler_);
  #line 21 "src/sampler/MarginalizedParticleImportanceSampler.birch"
  libbirch_line_(21);
  #line 21 "src/sampler/MarginalizedParticleImportanceSampler.birch"
  filter->initialize(archetype, handler_);
  #line 22 "src/sampler/MarginalizedParticleImportanceSampler.birch"
  libbirch_line_(22);
  #line 22 "src/sampler/MarginalizedParticleImportanceSampler.birch"
  filter->filter(handler_);
  #line 23 "src/sampler/MarginalizedParticleImportanceSampler.birch"
  libbirch_line_(23);
  #line 23 "src/sampler/MarginalizedParticleImportanceSampler.birch"
  this_()->pushDiagnostics(filter, handler_);
  #line 24 "src/sampler/MarginalizedParticleImportanceSampler.birch"
  libbirch_line_(24);
  #line 24 "src/sampler/MarginalizedParticleImportanceSampler.birch"
  for (auto t = birch::type::Integer(1); t <= filter->size(handler_); ++t) {
    #line 25 "src/sampler/MarginalizedParticleImportanceSampler.birch"
    libbirch_line_(25);
    #line 25 "src/sampler/MarginalizedParticleImportanceSampler.birch"
    filter->filter(t, handler_);
    #line 26 "src/sampler/MarginalizedParticleImportanceSampler.birch"
    libbirch_line_(26);
    #line 26 "src/sampler/MarginalizedParticleImportanceSampler.birch"
    this_()->pushDiagnostics(filter, handler_);
  }
  #line 30 "src/sampler/MarginalizedParticleImportanceSampler.birch"
  libbirch_line_(30);
  #line 30 "src/sampler/MarginalizedParticleImportanceSampler.birch"
  auto b = birch::ancestor(filter->w, handler_);
  #line 31 "src/sampler/MarginalizedParticleImportanceSampler.birch"
  libbirch_line_(31);
  #line 31 "src/sampler/MarginalizedParticleImportanceSampler.birch"
  if (b == birch::type::Integer(0)) {
    #line 32 "src/sampler/MarginalizedParticleImportanceSampler.birch"
    libbirch_line_(32);
    #line 32 "src/sampler/MarginalizedParticleImportanceSampler.birch"
    birch::warn(birch::type::String("particle filter degenerated, problem sample will be assigned zero weight"), handler_);
    #line 33 "src/sampler/MarginalizedParticleImportanceSampler.birch"
    libbirch_line_(33);
    #line 33 "src/sampler/MarginalizedParticleImportanceSampler.birch"
    this_()->w = -birch::inf();
  } else {
    #line 35 "src/sampler/MarginalizedParticleImportanceSampler.birch"
    libbirch_line_(35);
    #line 35 "src/sampler/MarginalizedParticleImportanceSampler.birch"
    this_()->x = filter->x.get(libbirch::make_slice(b - 1))->m;
    #line 36 "src/sampler/MarginalizedParticleImportanceSampler.birch"
    libbirch_line_(36);
    #line 36 "src/sampler/MarginalizedParticleImportanceSampler.birch"
    this_()->w = filter->lnormalize;
  }
  #line 38 "src/sampler/MarginalizedParticleImportanceSampler.birch"
  libbirch_line_(38);
  #line 38 "src/sampler/MarginalizedParticleImportanceSampler.birch"
  birch::collect(handler_);
}

#line 1 "src/sampler/MarginalizedParticleImportanceSampler.birch"
birch::type::MarginalizedParticleImportanceSampler* birch::type::make_MarginalizedParticleImportanceSampler_() {
  #line 1 "src/sampler/MarginalizedParticleImportanceSampler.birch"
  return new birch::type::MarginalizedParticleImportanceSampler();
  #line 1 "src/sampler/MarginalizedParticleImportanceSampler.birch"
}

#line 1 "src/sampler/ParticleGibbsSampler.birch"
birch::type::ParticleGibbsSampler::ParticleGibbsSampler(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_) :
    #line 1 "src/sampler/ParticleGibbsSampler.birch"
    super_type_() {
  //
}

#line 18 "src/sampler/ParticleGibbsSampler.birch"
void birch::type::ParticleGibbsSampler::sample(const libbirch::Lazy<libbirch::Shared<birch::type::ConditionalParticleFilter>>& filter, const libbirch::Lazy<libbirch::Shared<birch::type::Model>>& archetype, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_) {
  #line 18 "src/sampler/ParticleGibbsSampler.birch"
  libbirch_function_("sample", "src/sampler/ParticleGibbsSampler.birch", 18);
  #line 20 "src/sampler/ParticleGibbsSampler.birch"
  libbirch_line_(20);
  #line 20 "src/sampler/ParticleGibbsSampler.birch"
  filter->alreadyInitialized = true;
}

#line 23 "src/sampler/ParticleGibbsSampler.birch"
void birch::type::ParticleGibbsSampler::sample(const libbirch::Lazy<libbirch::Shared<birch::type::ConditionalParticleFilter>>& filter, const libbirch::Lazy<libbirch::Shared<birch::type::Model>>& archetype, const birch::type::Integer& n, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_) {
  #line 23 "src/sampler/ParticleGibbsSampler.birch"
  libbirch_function_("sample", "src/sampler/ParticleGibbsSampler.birch", 23);
  #line 25 "src/sampler/ParticleGibbsSampler.birch"
  libbirch_line_(25);
  #line 25 "src/sampler/ParticleGibbsSampler.birch"
  this_()->clearDiagnostics(handler_);
  #line 27 "src/sampler/ParticleGibbsSampler.birch"
  libbirch_line_(27);
  #line 27 "src/sampler/ParticleGibbsSampler.birch"
  if (filter->r.query()) {
    #line 29 "src/sampler/ParticleGibbsSampler.birch"
    libbirch_line_(29);
    #line 29 "src/sampler/ParticleGibbsSampler.birch"
    libbirch::Lazy<libbirch::Shared<birch::type::Tape<libbirch::Lazy<libbirch::Shared<birch::type::Record>>>>> r = filter->r.get();
    #line 30 "src/sampler/ParticleGibbsSampler.birch"
    libbirch_line_(30);
    #line 30 "src/sampler/ParticleGibbsSampler.birch"
    libbirch::Lazy<libbirch::Shared<birch::type::Tape<libbirch::Lazy<libbirch::Shared<birch::type::Record>>>>> r_prime_;
    #line 32 "src/sampler/ParticleGibbsSampler.birch"
    libbirch_line_(32);
    #line 32 "src/sampler/ParticleGibbsSampler.birch"
    auto x_prime_ = birch::clone(archetype, handler_);
    #line 33 "src/sampler/ParticleGibbsSampler.birch"
    libbirch_line_(33);
    #line 33 "src/sampler/ParticleGibbsSampler.birch"
    auto handler = birch::PlayHandler(true, handler_);
    #line 34 "src/sampler/ParticleGibbsSampler.birch"
    libbirch_line_(34);
    #line 34 "src/sampler/ParticleGibbsSampler.birch"
    handler->output = r_prime_;
    #line 35 "src/sampler/ParticleGibbsSampler.birch"
    libbirch_line_(35);
    #line 35 "src/sampler/ParticleGibbsSampler.birch"
    {
      auto handler_ = (handler);
      #line 36 "src/sampler/ParticleGibbsSampler.birch"
      libbirch_line_(36);
      #line 36 "src/sampler/ParticleGibbsSampler.birch"
      x_prime_->simulate(handler_);
    }
    #line 38 "src/sampler/ParticleGibbsSampler.birch"
    libbirch_line_(38);
    #line 38 "src/sampler/ParticleGibbsSampler.birch"
    auto w_prime_ = handler->w;
    #line 40 "src/sampler/ParticleGibbsSampler.birch"
    libbirch_line_(40);
    #line 40 "src/sampler/ParticleGibbsSampler.birch"
    handler = birch::PlayHandler(filter->delayed, handler_);
    #line 41 "src/sampler/ParticleGibbsSampler.birch"
    libbirch_line_(41);
    #line 41 "src/sampler/ParticleGibbsSampler.birch"
    handler->input = filter->r.get();
    #line 42 "src/sampler/ParticleGibbsSampler.birch"
    libbirch_line_(42);
    #line 42 "src/sampler/ParticleGibbsSampler.birch"
    {
      auto handler_ = (handler);
      #line 43 "src/sampler/ParticleGibbsSampler.birch"
      libbirch_line_(43);
      #line 43 "src/sampler/ParticleGibbsSampler.birch"
      for (auto t = birch::type::Integer(1); t <= filter->size(handler_); ++t) {
        #line 44 "src/sampler/ParticleGibbsSampler.birch"
        libbirch_line_(44);
        #line 44 "src/sampler/ParticleGibbsSampler.birch"
        x_prime_->simulate(t, handler_);
      }
    }
    #line 47 "src/sampler/ParticleGibbsSampler.birch"
    libbirch_line_(47);
    #line 47 "src/sampler/ParticleGibbsSampler.birch"
    w_prime_ = w_prime_ + handler->w;
    #line 49 "src/sampler/ParticleGibbsSampler.birch"
    libbirch_line_(49);
    #line 49 "src/sampler/ParticleGibbsSampler.birch"
    x_prime_ = birch::clone(archetype, handler_);
    #line 50 "src/sampler/ParticleGibbsSampler.birch"
    libbirch_line_(50);
    #line 50 "src/sampler/ParticleGibbsSampler.birch"
    handler = birch::PlayHandler(filter->delayed, handler_);
    #line 51 "src/sampler/ParticleGibbsSampler.birch"
    libbirch_line_(51);
    #line 51 "src/sampler/ParticleGibbsSampler.birch"
    handler->input = r_prime_;
    #line 52 "src/sampler/ParticleGibbsSampler.birch"
    libbirch_line_(52);
    #line 52 "src/sampler/ParticleGibbsSampler.birch"
    {
      auto handler_ = (handler);
      #line 53 "src/sampler/ParticleGibbsSampler.birch"
      libbirch_line_(53);
      #line 53 "src/sampler/ParticleGibbsSampler.birch"
      x_prime_->simulate(handler_);
    }
    #line 55 "src/sampler/ParticleGibbsSampler.birch"
    libbirch_line_(55);
    #line 55 "src/sampler/ParticleGibbsSampler.birch"
    this_()->lnormalize->pushBack(handler->w, handler_);
    #line 56 "src/sampler/ParticleGibbsSampler.birch"
    libbirch_line_(56);
    #line 56 "src/sampler/ParticleGibbsSampler.birch"
    this_()->ess->pushBack(1.0, handler_);
    #line 57 "src/sampler/ParticleGibbsSampler.birch"
    libbirch_line_(57);
    #line 57 "src/sampler/ParticleGibbsSampler.birch"
    this_()->npropagations->pushBack(birch::type::Integer(1), handler_);
    #line 58 "src/sampler/ParticleGibbsSampler.birch"
    libbirch_line_(58);
    #line 58 "src/sampler/ParticleGibbsSampler.birch"
    filter->r.get()->rewind(handler_);
  }
  #line 61 "src/sampler/ParticleGibbsSampler.birch"
  libbirch_line_(61);
  #line 61 "src/sampler/ParticleGibbsSampler.birch"
  filter->initialize(archetype, handler_);
  #line 62 "src/sampler/ParticleGibbsSampler.birch"
  libbirch_line_(62);
  #line 62 "src/sampler/ParticleGibbsSampler.birch"
  filter->filter(handler_);
  #line 63 "src/sampler/ParticleGibbsSampler.birch"
  libbirch_line_(63);
  #line 63 "src/sampler/ParticleGibbsSampler.birch"
  this_()->pushDiagnostics(filter, handler_);
  #line 64 "src/sampler/ParticleGibbsSampler.birch"
  libbirch_line_(64);
  #line 64 "src/sampler/ParticleGibbsSampler.birch"
  for (auto t = birch::type::Integer(1); t <= filter->size(handler_); ++t) {
    #line 65 "src/sampler/ParticleGibbsSampler.birch"
    libbirch_line_(65);
    #line 65 "src/sampler/ParticleGibbsSampler.birch"
    filter->filter(t, handler_);
    #line 66 "src/sampler/ParticleGibbsSampler.birch"
    libbirch_line_(66);
    #line 66 "src/sampler/ParticleGibbsSampler.birch"
    this_()->pushDiagnostics(filter, handler_);
  }
  #line 70 "src/sampler/ParticleGibbsSampler.birch"
  libbirch_line_(70);
  #line 70 "src/sampler/ParticleGibbsSampler.birch"
  filter->b = birch::ancestor(filter->w, handler_);
  #line 71 "src/sampler/ParticleGibbsSampler.birch"
  libbirch_line_(71);
  #line 71 "src/sampler/ParticleGibbsSampler.birch"
  if (filter->b == birch::type::Integer(0)) {
    #line 72 "src/sampler/ParticleGibbsSampler.birch"
    libbirch_line_(72);
    #line 72 "src/sampler/ParticleGibbsSampler.birch"
    birch::error(birch::type::String("particle filter degenerated"), handler_);
  }
  #line 74 "src/sampler/ParticleGibbsSampler.birch"
  libbirch_line_(74);
  #line 74 "src/sampler/ParticleGibbsSampler.birch"
  this_()->x = filter->x.get(libbirch::make_slice(filter->b - 1))->m;
  #line 75 "src/sampler/ParticleGibbsSampler.birch"
  libbirch_line_(75);
  #line 75 "src/sampler/ParticleGibbsSampler.birch"
  this_()->w = 0.0;
  #line 77 "src/sampler/ParticleGibbsSampler.birch"
  libbirch_line_(77);
  #line 77 "src/sampler/ParticleGibbsSampler.birch"
  birch::collect(handler_);
}

#line 1 "src/sampler/ParticleGibbsSampler.birch"
birch::type::ParticleGibbsSampler* birch::type::make_ParticleGibbsSampler_() {
  #line 1 "src/sampler/ParticleGibbsSampler.birch"
  return new birch::type::ParticleGibbsSampler();
  #line 1 "src/sampler/ParticleGibbsSampler.birch"
}

#line 17 "src/sampler/ParticleSampler.birch"
birch::type::ParticleSampler::ParticleSampler(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_) :
    #line 17 "src/sampler/ParticleSampler.birch"
    super_type_(),
    #line 21 "src/sampler/ParticleSampler.birch"
    x(),
    #line 26 "src/sampler/ParticleSampler.birch"
    w(0.0),
    #line 31 "src/sampler/ParticleSampler.birch"
    lnormalize(),
    #line 36 "src/sampler/ParticleSampler.birch"
    ess(),
    #line 41 "src/sampler/ParticleSampler.birch"
    npropagations(),
    #line 46 "src/sampler/ParticleSampler.birch"
    raccepts(),
    #line 51 "src/sampler/ParticleSampler.birch"
    nsamples(birch::type::Integer(1)) {
  //
}

#line 57 "src/sampler/ParticleSampler.birch"
birch::type::Integer birch::type::ParticleSampler::size(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_) {
  #line 57 "src/sampler/ParticleSampler.birch"
  libbirch_function_("size", "src/sampler/ParticleSampler.birch", 57);
  #line 58 "src/sampler/ParticleSampler.birch"
  libbirch_line_(58);
  #line 58 "src/sampler/ParticleSampler.birch"
  return this_()->nsamples;
}

#line 69 "src/sampler/ParticleSampler.birch"
void birch::type::ParticleSampler::sample(const libbirch::Lazy<libbirch::Shared<birch::type::ParticleFilter>>& filter, const libbirch::Lazy<libbirch::Shared<birch::type::Model>>& archetype, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_) {
  #line 69 "src/sampler/ParticleSampler.birch"
  libbirch_function_("sample", "src/sampler/ParticleSampler.birch", 69);
}

#line 88 "src/sampler/ParticleSampler.birch"
void birch::type::ParticleSampler::clearDiagnostics(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_) {
  #line 88 "src/sampler/ParticleSampler.birch"
  libbirch_function_("clearDiagnostics", "src/sampler/ParticleSampler.birch", 88);
  #line 89 "src/sampler/ParticleSampler.birch"
  libbirch_line_(89);
  #line 89 "src/sampler/ParticleSampler.birch"
  this_()->lnormalize->clear(handler_);
  #line 90 "src/sampler/ParticleSampler.birch"
  libbirch_line_(90);
  #line 90 "src/sampler/ParticleSampler.birch"
  this_()->ess->clear(handler_);
  #line 91 "src/sampler/ParticleSampler.birch"
  libbirch_line_(91);
  #line 91 "src/sampler/ParticleSampler.birch"
  this_()->npropagations->clear(handler_);
  #line 92 "src/sampler/ParticleSampler.birch"
  libbirch_line_(92);
  #line 92 "src/sampler/ParticleSampler.birch"
  this_()->raccepts->clear(handler_);
}

#line 98 "src/sampler/ParticleSampler.birch"
void birch::type::ParticleSampler::pushDiagnostics(const libbirch::Lazy<libbirch::Shared<birch::type::ParticleFilter>>& filter, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_) {
  #line 98 "src/sampler/ParticleSampler.birch"
  libbirch_function_("pushDiagnostics", "src/sampler/ParticleSampler.birch", 98);
  #line 99 "src/sampler/ParticleSampler.birch"
  libbirch_line_(99);
  #line 99 "src/sampler/ParticleSampler.birch"
  this_()->lnormalize->pushBack(filter->lnormalize, handler_);
  #line 100 "src/sampler/ParticleSampler.birch"
  libbirch_line_(100);
  #line 100 "src/sampler/ParticleSampler.birch"
  this_()->ess->pushBack(filter->ess, handler_);
  #line 101 "src/sampler/ParticleSampler.birch"
  libbirch_line_(101);
  #line 101 "src/sampler/ParticleSampler.birch"
  this_()->npropagations->pushBack(filter->npropagations, handler_);
  #line 102 "src/sampler/ParticleSampler.birch"
  libbirch_line_(102);
  #line 102 "src/sampler/ParticleSampler.birch"
  this_()->raccepts->pushBack(filter->raccept, handler_);
}

#line 108 "src/sampler/ParticleSampler.birch"
void birch::type::ParticleSampler::write(const libbirch::Lazy<libbirch::Shared<birch::type::Buffer>>& buffer, const birch::type::Integer& n, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_) {
  #line 108 "src/sampler/ParticleSampler.birch"
  libbirch_function_("write", "src/sampler/ParticleSampler.birch", 108);
  #line 109 "src/sampler/ParticleSampler.birch"
  libbirch_line_(109);
  #line 109 "src/sampler/ParticleSampler.birch"
  buffer->set(birch::type::String("sample"), birch::clone(this_()->x.get(), handler_), handler_);
  #line 110 "src/sampler/ParticleSampler.birch"
  libbirch_line_(110);
  #line 110 "src/sampler/ParticleSampler.birch"
  buffer->set(birch::type::String("lweight"), this_()->w, handler_);
  #line 111 "src/sampler/ParticleSampler.birch"
  libbirch_line_(111);
  #line 111 "src/sampler/ParticleSampler.birch"
  buffer->set(birch::type::String("lnormalize"), this_()->lnormalize, handler_);
  #line 112 "src/sampler/ParticleSampler.birch"
  libbirch_line_(112);
  #line 112 "src/sampler/ParticleSampler.birch"
  buffer->set(birch::type::String("ess"), this_()->ess, handler_);
  #line 113 "src/sampler/ParticleSampler.birch"
  libbirch_line_(113);
  #line 113 "src/sampler/ParticleSampler.birch"
  buffer->set(birch::type::String("npropagations"), this_()->npropagations, handler_);
  #line 114 "src/sampler/ParticleSampler.birch"
  libbirch_line_(114);
  #line 114 "src/sampler/ParticleSampler.birch"
  buffer->set(birch::type::String("raccepts"), this_()->raccepts, handler_);
}

#line 117 "src/sampler/ParticleSampler.birch"
void birch::type::ParticleSampler::read(const libbirch::Lazy<libbirch::Shared<birch::type::Buffer>>& buffer, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_) {
  #line 117 "src/sampler/ParticleSampler.birch"
  libbirch_function_("read", "src/sampler/ParticleSampler.birch", 117);
  #line 118 "src/sampler/ParticleSampler.birch"
  libbirch_line_(118);
  #line 118 "src/sampler/ParticleSampler.birch"
  this_()->super_type_::read(buffer, handler_);
  #line 119 "src/sampler/ParticleSampler.birch"
  libbirch_line_(119);
  #line 119 "src/sampler/ParticleSampler.birch"
  libbirch::optional_assign(this_()->nsamples, buffer->get(birch::type::String("nsamples"), this_()->nsamples, handler_));
}

#line 122 "src/sampler/ParticleSampler.birch"
void birch::type::ParticleSampler::write(const libbirch::Lazy<libbirch::Shared<birch::type::Buffer>>& buffer, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_) {
  #line 122 "src/sampler/ParticleSampler.birch"
  libbirch_function_("write", "src/sampler/ParticleSampler.birch", 122);
  #line 123 "src/sampler/ParticleSampler.birch"
  libbirch_line_(123);
  #line 123 "src/sampler/ParticleSampler.birch"
  this_()->super_type_::write(buffer, handler_);
  #line 124 "src/sampler/ParticleSampler.birch"
  libbirch_line_(124);
  #line 124 "src/sampler/ParticleSampler.birch"
  buffer->set(birch::type::String("nsamples"), this_()->nsamples, handler_);
}

